package bitcoinity_test

import (
	_ "embed"
	"encoding/json"
	"testing"

	"code.humancabbage.net/moonmath/bitcoinity"
)

func TestUnmarshalGetTickerResponse(t *testing.T) {
	var resp bitcoinity.GetTickerResponse
	err := json.Unmarshal(getTickerJson, &resp)
	if err != nil {
		t.Errorf("failed to unmarshal get_ticker JSON: %v", err)
	}
	if resp.TickerLife != 604800 {
		t.Errorf("expected TickerLife == 604800, not %v", resp.TickerLife)
	}
}

//go:embed get_ticker.json
var getTickerJson []byte
